diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/maps/alchemy-flash.c linux-2.4.30/drivers/mtd/maps/alchemy-flash.c
--- linux-2.4.30-orig/drivers/mtd/maps/alchemy-flash.c	2005-05-12 18:01:30.000000000 +0200
+++ linux-2.4.30/drivers/mtd/maps/alchemy-flash.c	2006-12-11 18:18:37.000000000 +0100
@@ -1,9 +1,8 @@
 /*
  * Flash memory access on AMD Alchemy evaluation boards
  * 
- * $Id: db1550-flash.c,v 1.7 2004/11/04 13:24:14 gleixner Exp $
+ * $Id: alchemy-flash.c,v 1.2 2005/09/28 14:19:12 lel Exp $
  *
- * (C) 2004 Embedded Edge, LLC, based on db1550-flash.c:
  * (C) 2003, 2004 Pete Popov <ppopov@embeddedalley.com>
  * 
  */
@@ -74,11 +73,17 @@
 #define BOARD_FLASH_WIDTH 4 /* 32-bits */
 #endif
 
+#ifdef CONFIG_MIPS_I3_MMB3 
+#define BOARD_MAP_NAME "Db1550 Flash"
+#define BOARD_FLASH_SIZE 0x00200000 /* 2MB */
+#define BOARD_FLASH_WIDTH 4 /* 32-bits */
+#else
 #ifdef CONFIG_MIPS_DB1550
 #define BOARD_MAP_NAME "Db1550 Flash"
 #define BOARD_FLASH_SIZE 0x08000000 /* 128MB */
 #define BOARD_FLASH_WIDTH 4 /* 32-bits */
 #endif
+#endif
 
 #ifdef CONFIG_MIPS_DB1200
 #define BOARD_MAP_NAME "Db1200 Flash"
@@ -106,78 +111,8 @@
 #define USE_LOCAL_ACCESSORS /* why? */
 #endif
 
-
-#ifdef USE_LOCAL_ACCESSORS
-__u8 physmap_read8(struct map_info *map, unsigned long ofs)
-{
-	__u8 ret;
-	ret = __raw_readb(map->map_priv_1 + ofs);
-	DBG("read8 from %x, %x\n", (unsigned)(map->map_priv_1 + ofs), ret);
-	return ret;
-}
-
-__u16 physmap_read16(struct map_info *map, unsigned long ofs)
-{
-	__u16 ret;
-	ret = __raw_readw(map->map_priv_1 + ofs);
-	DBG("read16 from %x, %x\n", (unsigned)(map->map_priv_1 + ofs), ret);
-	return ret;
-}
-
-__u32 physmap_read32(struct map_info *map, unsigned long ofs)
-{
-	__u32 ret;
-	ret = __raw_readl(map->map_priv_1 + ofs);
-	DBG("read32 from %x, %x\n", (unsigned)(map->map_priv_1 + ofs), ret);
-	return ret;
-}
-
-void physmap_copy_from(struct map_info *map, void *to, unsigned long from, ssize_t len)
-{
-	DBG("physmap_copy from %x to %x\n", (unsigned)from, (unsigned)to);
-	memcpy_fromio(to, map->map_priv_1 + from, len);
-}
-
-void physmap_write8(struct map_info *map, __u8 d, unsigned long adr)
-{
-	DBG("write8 at %x, %x\n", (unsigned)(map->map_priv_1 + adr), d);
-	__raw_writeb(d, map->map_priv_1 + adr);
-	mb();
-}
-
-void physmap_write16(struct map_info *map, __u16 d, unsigned long adr)
-{
-	DBG("write16 at %x, %x\n", (unsigned)(map->map_priv_1 + adr), d);
-	__raw_writew(d, map->map_priv_1 + adr);
-	mb();
-}
-
-void physmap_write32(struct map_info *map, __u32 d, unsigned long adr)
-{
-	DBG("write32 at %x, %x\n", (unsigned)(map->map_priv_1 + adr), d);
-	__raw_writel(d, map->map_priv_1 + adr);
-	mb();
-}
-
-void physmap_copy_to(struct map_info *map, unsigned long to, const void *from, ssize_t len)
-{
-	DBG("physmap_copy_to %x from %x\n", (unsigned)to, (unsigned)from);
-	memcpy_toio(map->map_priv_1 + to, from, len);
-}
-#endif
-
 static struct map_info alchemy_map = {
 	.name =	BOARD_MAP_NAME,
-#ifdef USE_LOCAL_ACCESSORS
-	read8: physmap_read8,
-	read16: physmap_read16,
-	read32: physmap_read32,
-	copy_from: physmap_copy_from,
-	write8: physmap_write8,
-	write16: physmap_write16,
-	write32: physmap_write32,
-	copy_to: physmap_copy_to,
-#endif
 };
 
 static struct mtd_partition alchemy_partitions[] = {
@@ -188,12 +123,12 @@
         },{
                 .name = "YAMON",
                 .size = 0x0100000,
-				.offset = MTDPART_OFS_APPEND,
+		.offset = MTDPART_OFS_APPEND,
                 .mask_flags = MTD_WRITEABLE
         },{
                 .name = "raw kernel",
-				.size = (0x300000 - 0x40000), /* last 256KB is yamon env */
-				.offset = MTDPART_OFS_APPEND,
+		.size = (0x300000 - 0x40000), /* last 256KB is yamon env */
+		.offset = MTDPART_OFS_APPEND,
         }
 };
 
@@ -209,7 +144,7 @@
 	unsigned long window_size;
 	
 	/* Default flash buswidth */
-	alchemy_map.buswidth = BOARD_FLASH_WIDTH;
+	alchemy_map.bankwidth = BOARD_FLASH_WIDTH;
 
 	window_addr = 0x20000000 - BOARD_FLASH_SIZE;
 	window_size = BOARD_FLASH_SIZE;
@@ -233,10 +168,13 @@
 	 * specific machine settings might have been set above.
 	 */
 	printk(KERN_NOTICE BOARD_MAP_NAME ": probing %d-bit flash bus\n", 
-			alchemy_map.buswidth*8);
+			alchemy_map.bankwidth*8);
 	alchemy_map.virt = ioremap(window_addr, window_size);
 	mymtd = do_map_probe("cfi_probe", &alchemy_map);
-	if (!mymtd) return -ENXIO;
+	if (!mymtd) {
+		iounmap(alchemy_map.virt);
+		return -ENXIO;
+	}
 	mymtd->owner = THIS_MODULE;
 
 	add_mtd_partitions(mymtd, parts, nb_parts);
@@ -248,14 +186,13 @@
 	if (mymtd) {
 		del_mtd_partitions(mymtd);
 		map_destroy(mymtd);
-		iounmap((void *) alchemy_map.virt);
+		iounmap(alchemy_map.virt);
 	}
 }
 
 module_init(alchemy_mtd_init);
 module_exit(alchemy_mtd_cleanup);
 
-MODULE_AUTHOR("Embedded Edge, LLC");
+MODULE_AUTHOR("Embedded Alley Solutions, Inc");
 MODULE_DESCRIPTION(BOARD_MAP_NAME " MTD driver");
 MODULE_LICENSE("GPL");
-
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/maps/mood300-flash.c linux-2.4.30/drivers/mtd/maps/mood300-flash.c
--- linux-2.4.30-orig/drivers/mtd/maps/mood300-flash.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30/drivers/mtd/maps/mood300-flash.c	2006-12-11 18:18:37.000000000 +0100
@@ -0,0 +1,163 @@
+/*
+ * Flash memory access on Mood 300 board
+ * 
+ * (C) 2004 I3 Micro Technology AB based on db1550-flash.c:
+ * (C) 2004 Embedded Edge, LLC, based on db1550-flash.c:
+ * (C) 2003 Pete Popov <pete_popov@yahoo.com>
+ * 
+ */
+
+#include <linux/config.h>
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+
+#include <linux/mtd/mtd.h>
+#include <linux/mtd/map.h>
+#include <linux/mtd/partitions.h>
+
+#include <asm/io.h>
+#include <asm/au1000.h>
+
+#ifdef 	DEBUG_RW
+#define	DBG(x...)	printk(x)
+#else
+#define	DBG(x...)	
+#endif
+
+static unsigned long window_addr;
+static unsigned long window_size;
+
+
+static struct map_info mood300_map = {
+	.name =	"Mood 300 flash",
+};
+
+static unsigned char flash_buswidth = 2;
+
+/* 
+ * Support only 16/32MB NOR Flash parts
+ */
+
+static struct mtd_partition mood300_partitions[] = {
+        {
+                .name = "all",
+                .size =   0x00050000,
+                .offset = 0x0000000,
+		.mask_flags = MTD_WRITEABLE,
+	},{
+                .name = "mtd1",
+                .size =   0x00030000,
+                .offset = 0x0000000,
+		.mask_flags = MTD_WRITEABLE,
+        },{
+                .name = "mtd2",
+		.size = 0x00010000,
+		.offset = 0x00030000,
+        },{
+                .name = "mtd3",
+		.size = 0x00010000,
+		.offset = 0x00040000,
+		.mask_flags = MTD_WRITEABLE,
+        },{
+                .name = "mtd4",
+                .size = 0x00120000,
+		.offset = 0x000E0000,
+        },{
+                .name = "mtd7",
+                .size = 0x00030000,
+		.offset = 0x00050000,
+		.mask_flags = MTD_WRITEABLE,
+        },{
+                .name = "mtd8",
+                .size = 0x00030000,
+		.offset = 0x00080000,
+		.mask_flags = MTD_WRITEABLE,
+        }
+	,{
+                .name = "mtd9",
+                .size = 0x00030000,
+		.offset = 0x000b0000,
+		.mask_flags = MTD_WRITEABLE,
+        }
+
+};
+
+#define NB_OF(x)  (sizeof(x)/sizeof(x[0]))
+
+static struct mtd_info *mymtd;
+
+/*
+ * Probe the flash density and setup window address and size
+ * based on user CONFIG options. There are times when we don't
+ * want the MTD driver to be probing the boot or user flash,
+ * so having the option to enable only one bank is important.
+ */
+int setup_flash_params(void)
+{
+    window_addr = 0x1FC00000;
+
+#ifdef CONFIG_MTD_MOOD300_2MB
+    window_size = 0x00200000; 
+#else
+    window_size = 0x00400000; 
+#endif
+
+    return 0;
+}
+
+int __init mood300_mtd_init(void)
+{
+	struct mtd_partition *parts;
+	int nb_parts = 0;
+	
+	/* Default flash buswidth */
+	mood300_map.bankwidth = flash_buswidth;
+
+	if (setup_flash_params()) 
+		return -ENXIO;
+
+	/*
+	 * Static partition definition selection
+	 */
+	parts = mood300_partitions;
+	nb_parts = NB_OF(mood300_partitions);
+	mood300_map.size = window_size;
+
+	/*
+	 * Now let's probe for the actual flash.  Do it here since
+	 * specific machine settings might have been set above.
+	 */
+	printk(KERN_NOTICE "Mood 300 flash: probing %d-bit flash bus\n", 
+			mood300_map.bankwidth*8);
+	mood300_map.virt = 
+		(void __iomem *)ioremap(window_addr, window_size);
+	printk("ioremap(0x%08x, 0x%08x) = 0x%08x\n", (unsigned int)window_addr, (unsigned int)window_size, (unsigned int)mood300_map.virt);
+	mymtd = do_map_probe("cfi_probe", &mood300_map);
+	if (!mymtd) return -ENXIO;
+	mymtd->owner = THIS_MODULE;
+
+	OccupyMtdNumber(5);
+	OccupyMtdNumber(6);
+	add_mtd_partitions(mymtd, parts, nb_parts);
+	ReleaseMtdNumber(5);
+	ReleaseMtdNumber(6);
+	
+	return 0;
+}
+
+static void __exit mood300_mtd_cleanup(void)
+{
+	if (mymtd) {
+		del_mtd_partitions(mymtd);
+		map_destroy(mymtd);
+	}
+}
+
+module_init(mood300_mtd_init);
+module_exit(mood300_mtd_cleanup);
+
+MODULE_AUTHOR("I3 Micro Technology AB");
+MODULE_DESCRIPTION("Mood 300 mtd map driver");
+MODULE_LICENSE("GPL");
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/maps/pb1550-flash.c linux-2.4.30/drivers/mtd/maps/pb1550-flash.c
--- linux-2.4.30-orig/drivers/mtd/maps/pb1550-flash.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30/drivers/mtd/maps/pb1550-flash.c	2006-12-11 18:18:37.000000000 +0100
@@ -0,0 +1,202 @@
+/*
+ * Flash memory access on Alchemy Pb1550 board
+ * 
+ * (C) 2004 Embedded Edge, LLC, based on pb1550-flash.c:
+ * (C) 2003 Pete Popov <ppopov@pacbell.net>
+ * 
+ */
+
+#include <linux/config.h>
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+
+#include <linux/mtd/mtd.h>
+#include <linux/mtd/map.h>
+#include <linux/mtd/partitions.h>
+
+#include <asm/io.h>
+#include <asm/au1000.h>
+#include <asm/pb1550.h>
+
+#ifdef 	DEBUG_RW
+#define	DBG(x...)	printk(x)
+#else
+#define	DBG(x...)	
+#endif
+
+static unsigned long window_addr;
+static unsigned long window_size;
+
+
+static struct map_info pb1550_map = {
+	.name =	"Pb1550 flash",
+};
+
+static unsigned char flash_buswidth = 4;
+
+/* 
+ * Support only 64MB NOR Flash parts
+ */
+
+#ifdef PB1550_BOTH_BANKS
+/* both banks will be used. Combine the first bank and the first 
+ * part of the second bank together into a single jffs/jffs2
+ * partition.
+ */
+static struct mtd_partition pb1550_partitions[] = {
+	/* assume boot[2:0]:swap is '0000' or '1000', which translates to:
+	 * 1C00 0000 1FFF FFFF CE0 64MB Boot NOR Flash
+	 * 1800 0000 1BFF FFFF CE0 64MB Param NOR Flash
+	 */
+        {
+                .name = "User FS",
+                .size =   (0x1FC00000 - 0x18000000),
+                .offset = 0x0000000
+        },{
+                .name = "yamon",
+                .size = 0x0100000,
+		.offset = MTDPART_OFS_APPEND,
+                .mask_flags = MTD_WRITEABLE
+        },{
+                .name = "raw kernel",
+		.size = (0x300000 - 0x40000), /* last 256KB is yamon env */
+		.offset = MTDPART_OFS_APPEND,
+        }
+};
+#elif defined(PB1550_BOOT_ONLY)
+static struct mtd_partition pb1550_partitions[] = {
+	/* assume boot[2:0]:swap is '0000' or '1000', which translates to:
+	 * 1C00 0000 1FFF FFFF CE0 64MB Boot NOR Flash
+	 */
+        {
+                .name = "User FS",
+                .size =   0x03c00000,
+                .offset = 0x0000000
+        },{
+                .name = "yamon",
+                .size = 0x0100000,
+		.offset = MTDPART_OFS_APPEND,
+                .mask_flags = MTD_WRITEABLE
+        },{
+                .name = "raw kernel",
+		.size = (0x300000-0x40000), /* last 256KB is yamon env */
+		.offset = MTDPART_OFS_APPEND,
+        }
+};
+#elif defined(PB1550_USER_ONLY)
+static struct mtd_partition pb1550_partitions[] = {
+	/* assume boot[2:0]:swap is '0000' or '1000', which translates to:
+	 * 1800 0000 1BFF FFFF CE0 64MB Param NOR Flash
+	 */
+        {
+                .name = "User FS",
+                .size = (0x4000000 - 0x200000), /* reserve 2MB for raw kernel */
+                .offset = 0x0000000
+        },{
+                .name = "raw kernel",
+		.size = MTDPART_SIZ_FULL,
+		.offset = MTDPART_OFS_APPEND,
+        }
+};
+#else
+#error MTD_PB1550 define combo error /* should never happen */
+#endif
+
+#define NB_OF(x)  (sizeof(x)/sizeof(x[0]))
+
+static struct mtd_info *mymtd;
+
+/*
+ * Probe the flash density and setup window address and size
+ * based on user CONFIG options. There are times when we don't
+ * want the MTD driver to be probing the boot or user flash,
+ * so having the option to enable only one bank is important.
+ */
+int setup_flash_params(void)
+{
+	u16 boot_swapboot;
+	boot_swapboot = (au_readl(MEM_STSTAT) & (0x7<<1)) | 
+		((bcsr->status >> 6)  & 0x1);
+	printk("Pb1550 MTD: boot:swap %d\n", boot_swapboot);
+
+	switch (boot_swapboot) {
+		case 0: /* 512Mbit devices, both enabled */
+		case 1: 
+		case 8:
+		case 9: 
+#if defined(PB1550_BOTH_BANKS)
+			window_addr = 0x18000000;
+			window_size = 0x8000000; 
+#elif defined(PB1550_BOOT_ONLY)
+			window_addr = 0x1C000000;
+			window_size = 0x4000000; 
+#else /* USER ONLY */
+			window_addr = 0x1E000000;
+			window_size = 0x4000000; 
+#endif
+			break;
+		case 0xC:
+		case 0xD:
+		case 0xE:
+		case 0xF: 
+			/* 64 MB Boot NOR Flash is disabled */
+			/* and the start address is moved to 0x0C00000 */
+			window_addr = 0x0C000000;
+			window_size = 0x4000000; 
+		default:
+			printk("Pb1550 MTD: unsupported boot:swap setting\n");
+			return 1;
+	}
+	return 0;
+}
+
+int __init pb1550_mtd_init(void)
+{
+	struct mtd_partition *parts;
+	int nb_parts = 0;
+	
+	/* Default flash buswidth */
+	pb1550_map.buswidth = flash_buswidth;
+
+	if (setup_flash_params()) 
+		return -ENXIO;
+
+	/*
+	 * Static partition definition selection
+	 */
+	parts = pb1550_partitions;
+	nb_parts = NB_OF(pb1550_partitions);
+	pb1550_map.size = window_size;
+
+	/*
+	 * Now let's probe for the actual flash.  Do it here since
+	 * specific machine settings might have been set above.
+	 */
+	printk(KERN_NOTICE "Pb1550 flash: probing %d-bit flash bus\n", 
+			pb1550_map.buswidth*8);
+	pb1550_map.virt = 
+		(unsigned long)ioremap(window_addr, window_size);
+	mymtd = do_map_probe("cfi_probe", &pb1550_map);
+	if (!mymtd) return -ENXIO;
+	mymtd->owner = THIS_MODULE;
+
+	add_mtd_partitions(mymtd, parts, nb_parts);
+	return 0;
+}
+
+static void __exit pb1550_mtd_cleanup(void)
+{
+	if (mymtd) {
+		del_mtd_partitions(mymtd);
+		map_destroy(mymtd);
+	}
+}
+
+module_init(pb1550_mtd_init);
+module_exit(pb1550_mtd_cleanup);
+
+MODULE_AUTHOR("Embedded Edge, LLC");
+MODULE_DESCRIPTION("Pb1550 mtd map driver");
+MODULE_LICENSE("GPL");
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/maps/pb1xxx-flash.c linux-2.4.30/drivers/mtd/maps/pb1xxx-flash.c
--- linux-2.4.30-orig/drivers/mtd/maps/pb1xxx-flash.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30/drivers/mtd/maps/pb1xxx-flash.c	2006-12-11 18:18:37.000000000 +0100
@@ -0,0 +1,179 @@
+/*
+ * Flash memory access on Alchemy Pb1xxx boards
+ * 
+ * (C) 2001 Pete Popov <ppopov@mvista.com>
+ * 
+ * $Id: pb1xxx-flash.c,v 1.2 2005/09/28 14:19:26 lel Exp $
+ */
+
+#include <linux/config.h>
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/init.h>
+#include <linux/kernel.h>
+
+#include <linux/mtd/mtd.h>
+#include <linux/mtd/map.h>
+#include <linux/mtd/partitions.h>
+
+#include <asm/io.h>
+#include <asm/au1000.h>
+
+#ifdef 	DEBUG_RW
+#define	DBG(x...)	printk(x)
+#else
+#define	DBG(x...)	
+#endif
+
+#ifdef CONFIG_MIPS_PB1000
+
+#define WINDOW_ADDR 0x1F800000
+#define WINDOW_SIZE 0x800000
+
+static struct mtd_partition pb1xxx_partitions[] = {
+        {
+                .name         =  "yamon env",
+                .size         =   0x00020000,
+                .offset       =   0,
+                .mask_flags   =   MTD_WRITEABLE},
+	{
+                .name         =   "User FS",
+                .size         =   0x003e0000,
+                .offset       =   0x20000,},
+	{
+                .name         =   "boot code",
+                .size         =   0x100000,
+                .offset       =   0x400000,
+                .mask_flags   =   MTD_WRITEABLE},
+	{
+                .name         =   "raw/kernel",
+                .size         =   0x300000,
+                .offset       =   0x500000}
+};
+
+#elif defined(CONFIG_MIPS_PB1500) || defined(CONFIG_MIPS_PB1100)
+
+#if defined(CONFIG_MTD_PB1500_BOOT) && defined(CONFIG_MTD_PB1500_USER)
+/* both 32MB banks will be used. Combine the first 32MB bank and the
+ * first 28MB of the second bank together into a single jffs/jffs2
+ * partition.
+ */
+#define WINDOW_ADDR 0x1C000000
+#define WINDOW_SIZE 0x4000000
+static struct mtd_partition pb1xxx_partitions[] = {
+        {
+                .name         =   "User FS",
+                .size         =   0x3c00000,
+                .offset       =   0x0000000
+        },{
+                .name         =   "yamon",
+                .size         =   0x0100000,
+                .offset       =   0x3c00000,
+                .mask_flags   =   MTD_WRITEABLE
+        },{
+                .name         =   "raw kernel",
+                .size         =   0x02c0000,
+                .offset       =   0x3d00000
+        }
+};
+#elif defined(CONFIG_MTD_PB1500_BOOT) && !defined(CONFIG_MTD_PB1500_USER)
+#define WINDOW_ADDR 0x1E000000
+#define WINDOW_SIZE 0x2000000
+static struct mtd_partition pb1xxx_partitions[] = {
+        {
+                .name         =   "User FS",
+                .size         =   0x1c00000,
+                .offset       =   0x0000000
+        },{
+                .name         =   "yamon",
+                .size         =   0x0100000,
+                .offset       =   0x1c00000,
+                .mask_flags   =   MTD_WRITEABLE
+        },{
+                .name         =   "raw kernel",
+                .size         =   0x02c0000,
+                .offset       =   0x1d00000
+        }
+};
+#elif !defined(CONFIG_MTD_PB1500_BOOT) && defined(CONFIG_MTD_PB1500_USER)
+#define WINDOW_ADDR 0x1C000000
+#define WINDOW_SIZE 0x2000000
+static struct mtd_partition pb1xxx_partitions[] = {
+        {
+                .name         =   "User FS",
+                .size         =    0x1e00000,
+                .offset       =    0x0000000
+        },{
+                .name         =    "raw kernel",
+                .size         =    0x0200000,
+                .offset       =    0x1e00000,
+        }
+};
+#else
+#error MTD_PB1500 define combo error /* should never happen */
+#endif
+#else
+#error Unsupported board
+#endif
+
+#define NAME     	"Pb1x00 Linux Flash"
+#define PADDR    	WINDOW_ADDR
+#define BUSWIDTH	4
+#define SIZE		WINDOW_SIZE
+#define PARTITIONS	4
+
+static struct map_info pb1xxx_mtd_map = {
+	.name		= NAME,
+	.size		= SIZE,
+	.buswidth	= BUSWIDTH,
+	.phys		= PADDR,
+};
+
+static struct mtd_info *pb1xxx_mtd;
+
+int __init pb1xxx_mtd_init(void)
+{
+	struct mtd_partition *parts;
+	int nb_parts = 0;
+	char *part_type;
+	
+	/*
+	 * Static partition definition selection
+	 */
+	part_type = "static";
+	parts = pb1xxx_partitions;
+	nb_parts = ARRAY_SIZE(pb1xxx_partitions);
+
+	/*
+	 * Now let's probe for the actual flash.  Do it here since
+	 * specific machine settings might have been set above.
+	 */
+	printk(KERN_NOTICE "Pb1xxx flash: probing %d-bit flash bus\n", 
+			BUSWIDTH*8);
+	pb1xxx_mtd_map.virt = (unsigned long)ioremap(WINDOW_ADDR, WINDOW_SIZE);
+
+	simple_map_init(&pb1xxx_mtd_map);
+
+	pb1xxx_mtd = do_map_probe("cfi_probe", &pb1xxx_mtd_map);
+	if (!pb1xxx_mtd) return -ENXIO;
+	pb1xxx_mtd->owner = THIS_MODULE;
+
+	add_mtd_partitions(pb1xxx_mtd, parts, nb_parts);
+	return 0;
+}
+
+static void __exit pb1xxx_mtd_cleanup(void)
+{
+	if (pb1xxx_mtd) {
+		del_mtd_partitions(pb1xxx_mtd);
+		map_destroy(pb1xxx_mtd);
+		iounmap((void *) pb1xxx_mtd_map.virt);
+	}
+}
+
+module_init(pb1xxx_mtd_init);
+module_exit(pb1xxx_mtd_cleanup);
+
+MODULE_AUTHOR("Pete Popov");
+MODULE_DESCRIPTION("Pb1xxx CFI map driver");
+MODULE_LICENSE("GPL");
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/maps/physmap.c linux-2.4.30/drivers/mtd/maps/physmap.c
--- linux-2.4.30-orig/drivers/mtd/maps/physmap.c	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/mtd/maps/physmap.c	2006-12-11 18:18:37.000000000 +0100
@@ -1,5 +1,5 @@
 /*
- * $Id: physmap.c,v 1.30 2003/11/11 19:05:18 jsun Exp $
+ * $Id: physmap.c,v 1.2 2005/09/28 14:19:26 lel Exp $
  *
  * Normal mappings of chips in physical memory
  *
@@ -22,7 +22,12 @@
 
 static struct mtd_info *mymtd;
 
-struct map_info physmap_map = {.name = "phys_mapped_flash"};
+struct map_info physmap_map = {
+	.name = "phys_mapped_flash",
+	.phys = CONFIG_MTD_PHYSMAP_START,
+	.size = CONFIG_MTD_PHYSMAP_LEN,
+	.bankwidth = CONFIG_MTD_PHYSMAP_BANKWIDTH,
+};
 
 #ifdef CONFIG_MTD_PARTITIONS
 static struct mtd_partition *mtd_parts;
@@ -31,7 +36,7 @@
 static int num_physmap_partitions;
 static struct mtd_partition *physmap_partitions;
 
-char *part_probes[] __initdata = {"cmdlinepart", "RedBoot", NULL};
+static const char *part_probes[] __initdata = {"cmdlinepart", "RedBoot", NULL};
 
 void physmap_set_partitions(struct mtd_partition *parts, int num_parts)
 {
@@ -40,13 +45,13 @@
 }
 #endif /* CONFIG_MTD_PARTITIONS */
 
-int __init init_physmap(void)
+static int __init init_physmap(void)
 {
-	static const char *rom_probe_types[] = { "cfi_probe", "jedec_probe", "map_rom", 0 };
+	static const char *rom_probe_types[] = { "cfi_probe", "jedec_probe", "map_rom", NULL };
 	const char **type;
 
        	printk(KERN_NOTICE "physmap flash device: %lx at %lx\n", physmap_map.size, physmap_map.phys);
-	physmap_map.virt = (unsigned long)ioremap(physmap_map.phys, physmap_map.size);
+	physmap_map.virt = ioremap(physmap_map.phys, physmap_map.size);
 
 	if (!physmap_map.virt) {
 		printk("Failed to ioremap\n");
@@ -55,7 +60,7 @@
 
 	simple_map_init(&physmap_map);
 
-	mymtd = 0;
+	mymtd = NULL;
 	type = rom_probe_types;
 	for(; !mymtd && *type; type++) {
 		mymtd = do_map_probe(*type, &physmap_map);
@@ -87,7 +92,7 @@
 		return 0;
 	}
 
-	iounmap((void *)physmap_map.virt);
+	iounmap(physmap_map.virt);
 	return -ENXIO;
 }
 
@@ -107,8 +112,8 @@
 #endif
 	map_destroy(mymtd);
 
-	iounmap((void *)physmap_map.virt);
-	physmap_map.virt = 0;
+	iounmap(physmap_map.virt);
+	physmap_map.virt = NULL;
 }
 
 module_init(init_physmap);
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/mtd_blkdevs-24.c linux-2.4.30/drivers/mtd/mtd_blkdevs-24.c
--- linux-2.4.30-orig/drivers/mtd/mtd_blkdevs-24.c	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/mtd/mtd_blkdevs-24.c	2006-12-11 18:18:37.000000000 +0100
@@ -1,5 +1,5 @@
 /*
- * $Id: mtd_blkdevs-24.c,v 1.15 2003/10/10 08:55:03 dwmw2 Exp $
+ * $Id: mtd_blkdevs-24.c,v 1.2 2005/09/28 14:18:56 lel Exp $
  *
  * (C) 2003 David Woodhouse <dwmw2@infradead.org>
  *
@@ -124,19 +124,12 @@
 	   actually want to deal with signals. We can't just call 
 	   exit_sighand() since that'll cause an oops when we finally
 	   do exit. */
-
-#ifndef __rh_config_h__ /* HAVE_NPTL */
 	spin_lock_irq(&current->sigmask_lock);
 	sigfillset(&current->blocked);
-	recalc_sigpending(current);
-	spin_unlock_irq(&current->sigmask_lock);
-#else
-	spin_lock_irq(&current->sighand->siglock);
-	sigfillset(&current->blocked);
 	recalc_sigpending();
-	spin_unlock_irq(&current->sighand->siglock);
-#endif
-	daemonize();
+	spin_unlock_irq(&current->sigmask_lock);
+
+	daemonize("%sd", tr->name);
 
 	while (!tr->blkcore_priv->exiting) {
 		struct request *req;
@@ -322,7 +315,7 @@
 	}
 
 	grok_partitions(gd, minor, 1 << tr->part_bits, 
-			tr->blkcore_priv->sizes[minor]);
+                        dev->size);
 	up(&mtd_table_mutex);
 
 	return 0;
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/mtd_blkdevs.c linux-2.4.30/drivers/mtd/mtd_blkdevs.c
--- linux-2.4.30-orig/drivers/mtd/mtd_blkdevs.c	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/mtd/mtd_blkdevs.c	2006-12-11 18:18:37.000000000 +0100
@@ -1,5 +1,5 @@
 /*
- * $Id: mtd_blkdevs.c,v 1.21 2004/03/30 20:59:46 sjhill Exp $
+ * $Id: mtd_blkdevs.c,v 1.2 2005/09/28 14:18:56 lel Exp $
  *
  * (C) 2003 David Woodhouse <dwmw2@infradead.org>
  *
@@ -81,7 +81,7 @@
 	struct request_queue *rq = tr->blkcore_priv->rq;
 
 	/* we might get involved when memory gets low, so use PF_MEMALLOC */
-	current->flags |= PF_MEMALLOC;
+	current->flags |= PF_MEMALLOC | PF_NOFREEZE;
 
 	daemonize("%sd", tr->name);
 
@@ -143,7 +143,7 @@
 }
 
 
-int blktrans_open(struct inode *i, struct file *f)
+static int blktrans_open(struct inode *i, struct file *f)
 {
 	struct mtd_blktrans_dev *dev;
 	struct mtd_blktrans_ops *tr;
@@ -174,7 +174,7 @@
 	return ret;
 }
 
-int blktrans_release(struct inode *i, struct file *f)
+static int blktrans_release(struct inode *i, struct file *f)
 {
 	struct mtd_blktrans_dev *dev;
 	struct mtd_blktrans_ops *tr;
@@ -216,12 +216,11 @@
 
 			memset(&g, 0, sizeof(g));
 			ret = tr->getgeo(dev, &g);
-
 			if (ret)
 				return ret;
 
 			g.start = get_start_sect(inode->i_bdev);
-			if (copy_to_user((void *)arg, &g, sizeof(g)))
+			if (copy_to_user((void __user *)arg, &g, sizeof(g)))
 				return -EFAULT;
 			return 0;
 		} /* else */
@@ -327,7 +326,7 @@
 	return 0;
 }
 
-void blktrans_notify_remove(struct mtd_info *mtd)
+static void blktrans_notify_remove(struct mtd_info *mtd)
 {
 	struct list_head *this, *this2, *next;
 
@@ -343,7 +342,7 @@
 	}
 }
 
-void blktrans_notify_add(struct mtd_info *mtd)
+static void blktrans_notify_add(struct mtd_info *mtd)
 {
 	struct list_head *this;
 
@@ -403,8 +402,7 @@
 
 	tr->blkcore_priv->rq->queuedata = tr;
 
-	ret = kernel_thread(mtd_blktrans_thread, tr, 
-			    CLONE_FS|CLONE_FILES|CLONE_SIGHAND);
+	ret = kernel_thread(mtd_blktrans_thread, tr, CLONE_KERNEL);
 	if (ret < 0) {
 		blk_cleanup_queue(tr->blkcore_priv->rq);
 		unregister_blkdev(tr->major, tr->name);
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/mtdblock.c linux-2.4.30/drivers/mtd/mtdblock.c
--- linux-2.4.30-orig/drivers/mtd/mtdblock.c	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/mtd/mtdblock.c	2006-12-11 18:18:37.000000000 +0100
@@ -1,7 +1,7 @@
 /* 
  * Direct MTD block device access
  *
- * $Id: mtdblock.c,v 1.64 2003/10/04 17:14:14 dwmw2 Exp $
+ * $Id: mtdblock.c,v 1.2 2005/09/28 14:18:56 lel Exp $
  *
  * (C) 2000-2003 Nicolas Pitre <nico@cam.org>
  * (C) 1999-2003 David Woodhouse <dwmw2@infradead.org>
@@ -248,7 +248,7 @@
 			      unsigned long block, char *buf)
 {
 	struct mtdblk_dev *mtdblk = mtdblks[dev->devnum];
-	if (unlikely(!mtdblk->cache_data)) {
+	if (unlikely(!mtdblk->cache_data && mtdblk->cache_size)) {
 		mtdblk->cache_data = vmalloc(mtdblk->mtd->erasesize);
 		if (!mtdblk->cache_data)
 			return -EINTR;
@@ -361,7 +361,7 @@
 	kfree(dev);
 }
 
-struct mtd_blktrans_ops mtdblock_tr = {
+static struct mtd_blktrans_ops mtdblock_tr = {
 	.name		= "mtdblock",
 	.major		= 31,
 	.part_bits	= 0,
@@ -375,7 +375,7 @@
 	.owner		= THIS_MODULE,
 };
 
-int __init init_mtdblock(void)
+static int __init init_mtdblock(void)
 {
 	return register_mtd_blktrans(&mtdblock_tr);
 }
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/mtdblock_ro.c linux-2.4.30/drivers/mtd/mtdblock_ro.c
--- linux-2.4.30-orig/drivers/mtd/mtdblock_ro.c	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/mtd/mtdblock_ro.c	2006-12-11 18:18:37.000000000 +0100
@@ -1,5 +1,5 @@
 /*
- * $Id: mtdblock_ro.c,v 1.18 2003/06/23 12:00:08 dwmw2 Exp $
+ * $Id: mtdblock_ro.c,v 1.2 2005/09/28 14:18:56 lel Exp $
  *
  * (C) 2003 David Woodhouse <dwmw2@infradead.org>
  *
@@ -58,7 +58,7 @@
 	kfree(dev);
 }
 
-struct mtd_blktrans_ops mtdblock_tr = {
+static struct mtd_blktrans_ops mtdblock_tr = {
 	.name		= "mtdblock",
 	.major		= 31,
 	.part_bits	= 0,
